﻿package{
	import flash.display.*;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	
	public class Perliner extends Sprite
	{
		private var bmd:BitmapData;
		private var background:Bitmap;
		private var angle:Number = 0;
		private var painter:Sprite;
		private var matrix:Matrix ;
		private var color:uint = 0xff0000;
		private var filterObj:BlurFilter = new BlurFilter(1,2,2);
		
		public function Perliner():void
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmd = new BitmapData(stage.stageWidth,stage.stageHeight,true,0);
			background = new Bitmap(bmd);
			
			painter = new Sprite();
			
			addChild(background);
			
			init();
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function init():void
		{
			if (angle>0) painter.graphics.clear();
			painter.graphics.beginFill(color,1);
			painter.graphics.drawRect(0,0,mouseX/5,mouseY/3);
			painter.graphics.endFill();
		}
		private function enterHandler(e:Event):void
		{
			if(angle<stage.stageWidth){
				color=0xffffff;
				matrix = new Matrix();
				matrix.translate(angle,0);
				matrix.rotate(Math.abs(Math.cos(angle*Math.PI/180)));
				bmd.applyFilter(bmd,bmd.rect,new Point(0,0),filterObj);
				init();
				bmd.draw(painter,matrix);
				angle++;
			}else{
				angle = 0;
			}
		}
	}
}